<?php

/**
 * File PKHGsDebug.php
 *
 * @version $Id$
 * @copyright 2007 PKHG
 * To debug 'complicated' PHP-scripts.
 */
/**
 * Version 0.2 070816
 */
// Changelist
/**
 * 070816, the 4th and 5th parameter of msgAndMaybeStop interchanged, because
 * Session and Post parmaters are less often needed.
 */
/**
 */
// echo "begin";
class PKHGsDebug {
    var $label = "PKHG";
    var $silent = false;
    var $size = "h1";

    /**
     * Constructor
     */

    function PKHGsDebug($label = "PKHG")
    {
        $this->label = $label;
    }

    /**
     *
     * @parameter  $stop '-1' immediate return, true exit, false message but no exit
     *    or classparameter silent (true) is obeyed.
     * @parameter  $msg , the message to be displayed
     * @parameter  $color of the message
     * @parameter  $arrayArg , if an array variable keys values are printed
     * @parameter  $withSessionPost , true $_POST and $_SESSION are tried to show, false not done.
     */
    function msgAndMaybeStop($stop, $msg = '', $color = "black",
        $arrayArg = null, $withSessionPost = false)
    {
        $h = $this->size;
        if (($stop === -1) or ($this->silent)) {
            return;
        }
        if ($color == "") {
            $color = "blue";
        } ;
        $label = $this->label;
        echo "<$h style=color:$color>$label: $msg</$h>";
        // *
        if ($withSessionPost) {
            if (isset($_POST)) {
                if (!$_POST) {
                    echo "\$_Post empty";
                }
                foreach ($_POST as $key => $value) {
                    echo("<br />$label(_POST) $key => $value");
                }
            }
            if (isset($_SESSION)) {
                if (count($_SESSION) > 0) {
                    echo("<br />values of \$_SESSION");
                    foreach($_SESSION as $key => $value) {
                        echo("<br />$label(_SESSION) $key => $value");
                    }
                } else {
                    echo "<br />\$_Session is empty";
                }
            } else {
                echo "<br />no SESSION yet";
            }
        }
        if (is_array($arrayArg)) {
            ob_start();
            var_dump($arrayArg);
            $out = ob_get_contents();
            ob_end_clean();
            $out = "<pre>" . str_replace("\n", "<br />\n", $out) . "</pre>";
            var_export($out);
        } else if ($arrayArg != null) {
            echo("<br />par: $arrayArg");
        }
        if ($stop) {
            echo ("<h1 style=color:red>$label stop!");
            exit;
        }
    }

    /**
     * return at once ...
     */
    function setSilent($value)
    {
        $this->silent = $value;
    }

    /**
     * Eventually distinguisch output by size
     */
    function setSize($value)
    {
        switch ($value) {
            case 1:
                $this->size = "h1";
                break;
            case 2:
                $this->size = "h2";
                break;
            case 3:
                $this->size = "h3";
                break;
            case 4:
                $this->size = "h4";
                break;
            case 5:
                $this->size = "h5";
                break;
            default:
                $this->size = "h1";
        }
    }

    /**
     * Change label?
     */
    function setLabel($value)
    {
        $this->label = $value;
    }
}

?>